/* Homework 2 Problem 5
 *
 * Count the number of times SW0 is moved to the "1" position,
 * and display this on the 7-segment display.
 *
 * After a count of 9, it wraps around to 0.
 *
 */

.include "ubc-de1media-macros.s"

.equ	SW0mask,	0x01

.global	_start

.text
_start:		movia	r23, IOBASE
		movi	r4, 0

loop:

/* display count on LEDs and 7SEG */
display:	call	count2ten		/* keeps count between 0 and 9 */
		stwio	r2, LEDR(r23)
		mov	r4, r2

		call	ten2hex7seg	/* converts decimal to 7seg value */
		stwio	r2, HEX7SEG(r23)

/* wait for SW1 to go from 1 to 0 */
while1:		ldwio	r3, SWITCH(r23)
		andi	r3, r3, SW0mask
		bne	r3, r0, while1	/* wait while SW0=1 */

/* wait for SW0 to go from 0 to 1 */
while0:		ldwio	r3, SWITCH(r23)
		andi	r3, r3, SW0mask
		beq	r3, r0, while0	/* wait while SW0=0 */

increment:	addi	r4, r4, 1

		br	loop

/* function: count2ten
 * operation: reduces the count to a value between 0 and 9
 *            by subtracting all multiples of 10.
 * incoming parameter: r4 is a count
 * return value: r2 is between 0 and 9 inclusive
 */

count2ten:
		movi	r2, 10
		div	r2, r4, r2
		muli	r2, r2, 10
		sub	r2, r4, r2
		ret

/* function: ten2hex7seg
 * operation: converts a value between 0 and 9 into the 32-bit
 *            value needed for the 7-segment display.
 * incoming parameter: r4 is a value between 0 and 9 inclusive
 * return value: r2 is a 32-bit value for the 7-segment display
 */
ten2hex7seg:
		movia	r2, TABLE		/* use a lookup table */
		muli	r3, r4, 4
		add	r2, r2, r3		/* 4*r4 is # of bytes into table for 7segment value */
		ldw	r2, 0(r2)		/* lookup value at address TABLE + 4*r4 */
		orhi	r2, r2, 0xffff	/* turn off LEDs in HEX3 and HEX2 */
		ori	r2, r2, 0xff00	/* turn off LEDs in HEX1 */
		ret

.data
TABLE:
.word DIGIT0, DIGIT1, DIGIT2, DIGIT3, DIGIT4
.word DIGIT5, DIGIT6, DIGIT7, DIGIT8, DIGIT9

.end
